<template>
  <div class="app flex-row align-items-center">
    <div class="container justify-content-center col-md-5 col-sm-12">
      <b-card class="bg-primary text-center" style="margin-top: 20px;">
        <blockquote class="card-blockquote" style="padding:40px 0;">
          <h1>Welcome,</h1>
          <h3><b>{{ email}}</b>!</h3>
        </blockquote>
      </b-card>
      <b-button @click="addModal = true" variant="success" style="margin:20px 0; width: 100%;">Add new short link</b-button>
      <b-modal
        id="addItemModal"
        title="New short link"
        variant="success"
        header-bg-variant="success"
        content-class="success"
        v-model="addModal"
        @ok="registerUri"
        ok-variant="success"
      >
        <b-form-group
          description="This is the URI your new link is going to redirect to!"
          label="Long link"
          label-for="basicText"
          :label-cols="3"
        >
          <b-form-input :state="checkNewUri" v-model="newUri" id="basicText" type="text" placeholder="URI"/>
          <b-form-invalid-feedback id="basicText">
            The URI should start with <code>http://</code> or <code>https://</code>.
          </b-form-invalid-feedback>
        </b-form-group>
      </b-modal>
      <div  v-for="(item, index) in uris" v-bind:key="item.shortURI">
        <b-card :no-body="true">
          <b-card-body v-b-toggle="'accordion-' + index" class="p-0 clearfix">
            <a class="fa bg-primary p-4 px-5 mr-3 float-left" style="width: 235px; font-size: xx-large; font-family: -apple-system, BlinkMacSystemFont, Roboto, Arial, sans-serif; color: white;">
              <code>{{ item.shortURI }}</code>
            </a>
            <div class="h5 text-primary mb-0 pt-3" ><a :href="item.realURI" >{{ item.realURI }}</a></div>
            <div class="text-muted text-uppercase font-weight-bold font-xs">
              <b-badge :id="'badge1-' + index" v-if="!item.reachable" variant="warning" style="margin-right: 10px;">UNREACHABLE</b-badge>
              <b-badge :id="'badge2-' + index" v-else variant="dark" style="margin-right: 10px;">REACHABLE</b-badge>
              <b-badge :id="'badge3-' + index" v-if="!item.safe" variant="danger" style="margin-right: 10px;">NOT SECURE</b-badge>
              <b-badge :id="'badge4-' + index" v-else variant="info" style="margin-right: 10px;">SECURE</b-badge>
              <b-badge :id="'badge5-' + index" v-if="!item.activated" variant="secondary" style="margin-right: 10px;">INACTIVE</b-badge>
              <b-badge :id="'badge6-' + index" v-else variant="success" style="margin-right: 10px;">ACTIVE</b-badge>
            </div>
          </b-card-body>
        </b-card>
        <b-collapse :id="'accordion-' + index" accordion="my-accordion" role="tabpanel">
          <b-card>
            <b-card-body>
              <b-button @click="openHooksModal(item)" variant="outline-primary" style="margin-bottom:20px; width: 100%;">Hook list</b-button>
              <h4>Settings:</h4><br/>
              <div class="custom-control custom-checkbox">
                <input type="checkbox" class="custom-control-input" :id="'active-'+index" v-model="item.activated">
                <label class="custom-control-label" :for="'active-'+index">Active</label>
              </div>
            </b-card-body>
            <div slot="footer">
              <b-button @click="saveChangesUri(item)" type="submit" size="sm" variant="primary" style="margin-right: 5px;">Save</b-button>
              <b-button @click="openDeleteURIModal(item)" type="submit" size="sm" variant="danger">Remove</b-button>
            </div>
          </b-card>
          <b-modal
            :id="'modal-' + index"
            title="Are you sure you want to delete this short link?"
            variant="danger"
            header-bg-variant="danger"
            content-class="border-danger"
            v-model="dangerModal"
            @ok="deleteUri"
            ok-variant="danger"
          >
            You are trying to delete the short link <strong>{{ modalData.shortURI }}</strong>, which redirects to
            <strong>{{ modalData.realURI }}</strong>. Are you sure you want to continue?
          </b-modal>
          <b-modal
            :id="'hookModal-' + index"
            :title="'Hook list for '+ modalData.shortURI"
            variant="primary"
            header-bg-variant="primary"
            content-class="border-primary"
            v-model="hooksModal"
            @ok="hooksModal = false"
            ok-variant="primary"
            size="xl"
          >

            <b-button @click="addHookModal = true" variant="success" style="margin:20px 0; width: 100%;">Add new hook</b-button>
            <b-modal
              id="addHookModal"
              title="New hook"
              variant="success"
              header-bg-variant="success"
              content-class="success"
              v-model="addHookModal"
              @ok="registerHook"
              ok-variant="success"
              >
              <div class="custom-control custom-checkbox">
                <input type="checkbox" class="custom-control-input" id="hookActive" v-model="hookToAdd.active">
                <label class="custom-control-label" for="hookActive">Active</label>
              </div>
              <b-form-group label="Trigger #1" label-for="hookLabel1" :label-cols="3">
                <b-input-group>
                  <b-form-input id="hookLabel1" type="number" placeholder="Minutes" v-model="hookToAdd.trigger.minutes"/>
                  <b-input-group-append><b-input-group-text>minutes</b-input-group-text></b-input-group-append>
                </b-input-group>
              </b-form-group>
              <b-form-group label="Trigger #2" label-for="hookLabel2" :label-cols="3">
                <b-input-group>
                  <b-form-input id="hookLabel2" type="number" placeholder="Clicks" v-model="hookToAdd.trigger.clicks"/>
                  <b-input-group-append><b-input-group-text>clicks</b-input-group-text></b-input-group-append>
                </b-input-group>
              </b-form-group>
              <b-form-group label="HTTP actions" label-for="hookHTTPLabel" :label-cols="3">
                <b-form-textarea rows="10" id="hookHTTPLabel" type="description" placeholder="{ ... json }"
                                 v-bind:value="JSON.stringify(hookToAdd.actionsHTTP)"
                                 v-on:input="hookToAdd.actionsHTTP = JSON.parse($event.target.value)"/>
              </b-form-group>
              <b-form-group label="Mail actions" label-for="hookMailLabel" :label-cols="3">
                <b-form-textarea rows="10" id="hookMailLabel" type="description" placeholder="{ ... json }"
                                 v-bind:value="JSON.stringify(hookToAdd.actionsMail)"
                                 v-on:input="hookToAdd.actionsMail = JSON.parse($event.target.value)"/>
              </b-form-group>
            </b-modal>

            <div  v-for="(itemHook, indexHook) in hooks" v-bind:key="itemHook.hookId">
              <b-card :no-body="true">
                <b-card-body v-b-toggle="'hook-accordion-' + indexHook" class="p-0 clearfix">
                  <a class="fa bg-primary p-4 px-5 mr-3 float-left" style="font-size: xx-large; font-family: -apple-system, BlinkMacSystemFont, Roboto, Arial, sans-serif; color: white;">{{ itemHook.hookId }}</a>
                  <div v-if="itemHook.trigger.clicks" class="h5 text-primary mb-0 pt-3">{{ itemHook.trigger.clicks }} clicks</div>
                  <div v-else class="h5 text-primary mb-0 pt-3">{{ itemHook.trigger.minutes }} minutes</div>
                  <div class="text-muted text-uppercase font-weight-bold font-xs">
                    <b-badge v-if="!itemHook.active" variant="secondary" style="margin-right: 10px;">INACTIVE</b-badge>
                    <b-badge v-else variant="success" style="margin-right: 10px;">ACTIVE</b-badge>
                  </div>
                </b-card-body>
              </b-card>
              <b-collapse :id="'hook-accordion-' + indexHook" accordion="my-accordion-hook" role="tabpanel">
                <b-card>
                  <b-card-body>
                    <h4>Settings:</h4><br/>
                    <div class="custom-control custom-checkbox">
                      <input type="checkbox" class="custom-control-input" :id="'hookActive-'+indexHook" v-model="itemHook.active">
                      <label class="custom-control-label" :for="'hookActive-'+indexHook">Active</label>
                    </div>
                  </b-card-body>
                  <div slot="footer">
                    <b-button @click="updateHook(itemHook)" type="submit" size="sm" variant="primary" style="margin-right: 5px;">Save</b-button>
                    <b-button @click="openDeleteHookModal(itemHook)" type="submit" size="sm" variant="danger">Remove</b-button>
                  </div>
                </b-card>
                <b-modal
                  :id="'modal-' + index"
                  title="Are you sure you want to delete this hook?"
                  variant="danger"
                  header-bg-variant="danger"
                  content-class="border-danger"
                  v-model="dangerHookModal"
                  @ok="deleteHook"
                  ok-variant="danger"
                >
                  You are trying to delete the hook <strong>{{ hookModalData.hookId }}</strong>, which is set to
                  <strong>{{ hookModalData.trigger.clicks }} clicks</strong> and
                  <strong>{{ hookModalData.trigger.minutes }} minutes</strong>. Are you sure you want to continue?
                </b-modal>
              </b-collapse>
            </div>
          </b-modal>
        </b-collapse>
      </div>
      <b-button @click="summaryModal = true" variant="success" style="margin-bottom: 20px; width: 100%;">Make summary</b-button>
      <b-modal
        id="summaryModal"
        title="Summary"
        variant="info"
        header-bg-variant="info"
        content-class="info"
        v-model="summaryModal"
        @ok="summaryModal = false"
        ok-variant="info"
        size="sm"
      >
        <b-button @click="getGData('application/json')" variant="success" style="margin:20px 0; width: 100%;">Download as JSON</b-button>
        <b-button @click="getGData('text/csv')" variant="success" style="margin:20px 0; width: 100%;">Download as CSV</b-button>
        <b-button @click="getGData('application/pdf')" variant="success" style="margin:20px 0; width: 100%;">Download as PDF</b-button>
      </b-modal>
      <b-button @click="logout" variant="danger" style="margin-bottom: 20px; width: 100%;" href="/login">Logout</b-button>
    </div>
  </div>
</template>

<script>

  export default {
  name: 'Dashboard',
  created() {
    this.fetchData();
  },
  computed: {
    uris() {
      this.uri_list = this.$store.getters.uris;
      return this.$store.getters.uris;
    },
    hooks() {
      this.hook_list = this.$store.getters.hooks;
      return this.$store.getters.hooks;
    },
    checkNewUri() {
      return !!(this.newUri.includes("http://") || this.newUri.includes("https://"));
    }
  },
  data() {
    return {
      newUri: "",
      email: this.$store.getters.name,
      newData: {
        shortURI: null,
        realURI: null,
        active: true,
        accessible: true,
        secure: true
      },
      modalData: {
        shortURI: null,
        realURI: null,
        active: true,
        accessible: true,
        secure: true
      },
      hookModalData: {
        hookId: null,
        userId: null,
        uriId: null,
        active: null,
        trigger:
          {
            clicks: null,
            minutes: null
          },
        actionsHTTP: [],
        actionsMail: []
      },
      addModal: false,
      addHookModal: false,
      hooksModal: false,
      dangerModal: false,
      dangerHookModal: false,
      summaryModal: false,
      hookToAdd: {
        uriId: "abc1",
        active: true,
        trigger:
          {
            clicks: 15,
            minutes: 1
          },
        actionsHTTP: [
          {
            endpoint: "http://api.example.com/",
            verb: "POST",
            params: "params-example",
            body:
              {
                field1: "value1",
                field2: "value2"
              }
          }
        ],
        actionsMail: [
          {
            destinations: [
              "someone@mail.com",
              "example@example.com"
            ],
            subject: "15 clicks lol",
            text: "This is the body of the mail"
          },
        ]
      },
      hook_list: [
        {
          uriId: "abc1",
          active: true,
          trigger:
            {
              clicks: 1,
              minutes: 1
            },
          actionsHTTP: [
            {
              endpoint: "http://api.example.com/",
              verb: "POST",
              params: "params-example",
              body:
                {
                  field1: "value1",
                  field2: "value2"
                }
            }
          ],
          actionsMail: [
            {
              destinations: [
                  "someone@mail.com",
                  "example@example.com"
                ],
              subject: "15 clicks lol",
              text: "This is the body of the mail"
            },
          ]
        },
        {
          uriId: "abc1",
          active: true,
          trigger:
            {
              clicks: 1,
              minutes: 100
            },
          actionsHTTP: [
            {
              endpoint: "http://api.example.com/",
              verb: "GET",
              params: "get-params-example",
              body:
                {
                  field1: "2value1",
                  field2: "2value2"
                }
            }
          ],
          actionsMail: [
            {
              destinations: [
                "someone2@mail.com",
                "example2@example.com"
              ],
              subject: "Oi 100 minutes",
              text: "This is the body of the mail --- 100 minutes"
            },
          ]
        },
        {
          uriId: "abc1",
          active: false,
          trigger:
            {
              clicks: 30,
              minutes: 1
            },
          actionsHTTP: [
            {
              endpoint: "http://api.example.com/",
              verb: "POST",
              params: "params-example",
              body:
                {
                  field1: "3value1",
                  field2: "3value2"
                }
            }
          ],
          actionsMail: [
            {
              destinations: [
                "someone3@mail.com",
                "example3@example.com"
              ],
              subject: "30 clicks lol",
              text: "This is thkljñlkje body of the mail"
            },
          ]
        }
      ],
      uri_list: [
        {
          shortURI: 'abc1',
          realURI: 'https://www.twitter.com/',
          active: true,
          accessible: true,
          secure: true
        },
        {
          shortURI: 'dnu32',
          realURI: 'https://www.google.com/',
          active: false,
          accessible: true,
          secure: true
        },
        {
          shortURI: 'fsq21d',
          realURI: 'https://www.jaja.lol/',
          active: true,
          accessible: false,
          secure: true
        },
      ]
    }
  },
  methods: {
    fetchData() {
      this.$store
        .dispatch("retrieveProfile")
        .then(() => this.$router.push("/"))
        .catch(err => console.log(err));
    },
    openDeleteURIModal(data) {
      this.modalData = data;
      this.dangerModal = true;
    },
    openDeleteHookModal(data) {
      this.hookModalData = data;
      this.dangerHookModal = true;
    },
    openHooksModal(data) {
      console.log("--------------------");
      this.$store
        .dispatch("retrieveHooks", data.shortURI)
        .catch(err => console.log(err));
      this.modalData = data;
      this.hooksModal = true;
    },
    registerUri(evt) {
      evt.preventDefault();
      let data = {
        "realURI": this.newUri
      };
      if (this.newUri.includes("http://") || this.newUri.includes("https://")) {
        this.$store
          .dispatch("newUri", data)
          .catch(err => console.log(err));
        this.addModal = false;
        (async()=>{
          await new Promise(resolve => setTimeout(resolve, 2000));
          this.fetchData()
        })();
      } else {
        alert("Please, specify a valid URI.")
      }
    },
    saveChangesUri(data) {
      if (data.activated) {
        this.$store
          .dispatch("activateUri", data.shortURI)
          .catch(err => console.log(err));
      } else {
        this.$store
          .dispatch("deactivateUri", data.shortURI)
          .catch(err => console.log(err));
      }
      (async()=>{
        await new Promise(resolve => setTimeout(resolve, 2000));
        this.fetchData()
      })();
    },
    deleteUri(evt) {
      evt.preventDefault();
      this.$store
        .dispatch("deleteUri", this.modalData.shortURI)
        .catch(err => console.log(err));
      this.dangerModal = false;
      (async()=>{
        await new Promise(resolve => setTimeout(resolve, 2000));
        this.fetchData()
      })();
    },
    registerHook(evt) {
      evt.preventDefault();
      this.hookToAdd.uriId = this.modalData.shortURI;
      this.$store
        .dispatch("addHook", this.hookToAdd)
        .catch(err => console.log(err));
      this.addHookModal = false;
      this.hooksModal = false;
      (async()=>{
        await new Promise(resolve => setTimeout(resolve, 2000));
        this.fetchData()
      })();
    },
    deleteHook(evt) {
      evt.preventDefault();
      this.$store
        .dispatch("deleteHook", this.hookModalData.hookId)
        .catch(err => console.log(err));
      this.dangerHookModal = false;
      (async()=>{
        await new Promise(resolve => setTimeout(resolve, 2000));
        this.fetchData()
      })();
    },
    updateHook(data) {
      if (data.active) {
        this.$store
          .dispatch("activateHook", data.hookId)
          .catch(err => console.log(err));
      } else {
        this.$store
          .dispatch("deactivateHook", data.hookId)
          .catch(err => console.log(err));
      }
      (async()=>{
        await new Promise(resolve => setTimeout(resolve, 2000));
        this.fetchData()
      })();
    },
    getGData(type) {
      this.$store
        .dispatch("getData", type)
        .catch(err => console.log(err));
    },
    logout() {
      this.$store
        .dispatch("logout")
        .then(() => this.$router.push("/"))
        .catch(err => console.log(err));
    }
  }
}
</script>
